"use strict";

var _ref = require("./script.js");

var parser = _ref.parser;
var Validator = require("./validator.js");

var Interpreter = {
  parse: function (input, allowDisabled) {
    if (!allowDisabled && Validator.includesDisabledOpcode(input)) {
      throw new Validator.DisabledOpcodeException(input);
    }

    return parser.parse(input);
  },

  evaluate: function (input, allowDisabled) {
    return Interpreter.parse(input, allowDisabled).value;
  },

  unlock: function (scriptSig, scriptPubKey, allowDisabled) {
    return Interpreter.evaluate(scriptSig + " " + scriptPubKey, allowDisabled);
  }
};

module.exports = Interpreter;