"use strict";

var DISABLED_OPCODES = [
/* Bitwise logic */
"OP_INVERT", "OP_AND", "OP_OR", "OP_XOR",
/* Arithmetic */
"OP_2MUL", "OP_2DIV", "OP_MUL", "OP_DIV", "OP_MOD", "OP_LSHIFT", "OP_RSHIFT"];

var Validator = {
  includesDisabledOpcode: function (input) {
    return Validator.getDisabledOpcode(input) != null;
  },

  getDisabledOpcode: function (input) {
    var minIdx = null;
    var minIdxOpcode = null;
    DISABLED_OPCODES.forEach(function (opcode) {
      var idx = input.indexOf(opcode);
      if (idx !== -1) {
        if (minIdx == null || idx < minIdx) {
          minIdx = idx;
          minIdxOpcode = opcode;
        }
      }
    });
    return minIdxOpcode;
  },

  DisabledOpcodeException: function (input) {
    var disabledOpcode = Validator.getDisabledOpcode(input);
    this.toString = function () {
      return "Included a disabled command: " + disabledOpcode;
    };
  }
};

module.exports = Validator;